"""
Four Square

Given a set of squares, try merging every pair of rectangles.
"""
import itertools


def fusions(a, b):
    for i in range(2):
        for j in range(2):
            if a[i] == b[j]:
                yield (a[i], a[i ^ 1] + b[j ^ 1])


def can_square(rects):
    assert rects
    if len(rects) == 1:
        return rects[0][0] == rects[0][1]

    n = len(rects)
    for fused_idxs in itertools.combinations(range(n), 2):
        rest = [rects[i] for i in range(n) if i not in fused_idxs]
        for fuse in fusions(*[rects[idx] for idx in fused_idxs]):
            if can_square(rest + [fuse]):
                return True

    return False


def main():
    rects = []
    for _ in range(4):
        w, h = map(int, input().split())
        rects.append((w, h))

    print(1 if can_square(rects) else 0)


if __name__ == "__main__":
    main()
